/*   -*- buffer-read-only: t -*- vi: set ro:
 *  
 *  DO NOT EDIT THIS FILE   (certtool-args.c)
 *  
 *  It has been AutoGen-ed  November 28, 2012 at 11:56:25 PM by AutoGen 5.16
 *  From the definitions    certtool-args.def
 *  and the template file   options
 *
 * Generated from AutoOpts 36:4:11 templates.
 *
 *  AutoOpts is a copyrighted work.  This source file is not encumbered
 *  by AutoOpts licensing, but is provided under the licensing terms chosen
 *  by the certtool author or copyright holder.  AutoOpts is
 *  licensed under the terms of the LGPL.  The redistributable library
 *  (``libopts'') is licensed under the terms of either the LGPL or, at the
 *  users discretion, the BSD license.  See the AutoOpts and/or libopts sources
 *  for details.
 *
 * The certtool program is copyrighted and licensed
 * under the following terms:
 *
 *  Copyright (C) 2000-2012 Free Software Foundation, all rights reserved.
 *  This is free software. It is licensed for use, modification and
 *  redistribution under the terms of the
 *  GNU General Public License, version 3 or later
 *      <http://gnu.org/licenses/gpl.html>
 *
 *  certtool is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  certtool is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along
 *  with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __doxygen__
#define OPTION_CODE_COMPILE 1
#include "certtool-args.h"
#include <sys/types.h>

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#ifdef  __cplusplus
extern "C" {
#endif
extern FILE * option_usage_fp;

/* TRANSLATORS: choose the translation for option names wisely because you
                cannot ever change your mind. */
#define zCopyright      (certtool_opt_strs+0)
#define zLicenseDescrip (certtool_opt_strs+279)


#ifndef NULL
#  define NULL 0
#endif

/*
 *  certtool option static const strings
 */
static char const certtool_opt_strs[4794] =
/*     0 */ "certtool @VERSION@\n"
            "Copyright (C) 2000-2012 Free Software Foundation, all rights reserved.\n"
            "This is free software. It is licensed for use, modification and\n"
            "redistribution under the terms of the\n"
            "GNU General Public License, version 3 or later\n"
            "    <http://gnu.org/licenses/gpl.html>\n\0"
/*   279 */ "certtool is free software: you can redistribute it and/or modify it under\n"
            "the terms of the GNU General Public License as published by the Free\n"
            "Software Foundation, either version 3 of the License, or (at your option)\n"
            "any later version.\n\n"
            "certtool is distributed in the hope that it will be useful, but WITHOUT ANY\n"
            "WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS\n"
            "FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more\n"
            "details.\n\n"
            "You should have received a copy of the GNU General Public License along\n"
            "with this program.  If not, see <http://www.gnu.org/licenses/>.\n\0"
/*   884 */ "Enable debugging.\0"
/*   902 */ "DEBUG\0"
/*   908 */ "debug\0"
/*   914 */ "More verbose output\0"
/*   934 */ "VERBOSE\0"
/*   942 */ "verbose\0"
/*   950 */ "Input file\0"
/*   961 */ "INFILE\0"
/*   968 */ "infile\0"
/*   975 */ "Output file\0"
/*   987 */ "OUTFILE\0"
/*   995 */ "outfile\0"
/*  1003 */ "Generate a self-signed certificate\0"
/*  1038 */ "GENERATE_SELF_SIGNED\0"
/*  1059 */ "generate-self-signed\0"
/*  1080 */ "Generate a signed certificate\0"
/*  1110 */ "GENERATE_CERTIFICATE\0"
/*  1131 */ "generate-certificate\0"
/*  1152 */ "Generates a proxy certificate\0"
/*  1182 */ "GENERATE_PROXY\0"
/*  1197 */ "generate-proxy\0"
/*  1212 */ "Generate a CRL\0"
/*  1227 */ "GENERATE_CRL\0"
/*  1240 */ "generate-crl\0"
/*  1253 */ "Update a signed certificate\0"
/*  1281 */ "UPDATE_CERTIFICATE\0"
/*  1300 */ "update-certificate\0"
/*  1319 */ "Generate a private key\0"
/*  1342 */ "GENERATE_PRIVKEY\0"
/*  1359 */ "generate-privkey\0"
/*  1376 */ "Generate a PKCS #10 certificate request\0"
/*  1416 */ "GENERATE_REQUEST\0"
/*  1433 */ "generate-request\0"
/*  1450 */ "Verify a PEM encoded certificate chain.\0"
/*  1490 */ "VERIFY_CHAIN\0"
/*  1503 */ "verify-chain\0"
/*  1516 */ "Verify a PEM encoded certificate chain using a trusted list.\0"
/*  1577 */ "VERIFY\0"
/*  1584 */ "verify\0"
/*  1591 */ "Verify a CRL using a trusted list.\0"
/*  1626 */ "VERIFY_CRL\0"
/*  1637 */ "verify-crl\0"
/*  1648 */ "Generate PKCS #3 encoded Diffie-Hellman parameters.\0"
/*  1700 */ "GENERATE_DH_PARAMS\0"
/*  1719 */ "generate-dh-params\0"
/*  1738 */ "Get the included PKCS #3 encoded Diffie-Hellman parameters.\0"
/*  1798 */ "GET_DH_PARAMS\0"
/*  1812 */ "get-dh-params\0"
/*  1826 */ "Print information PKCS #3 encoded Diffie-Hellman parameters\0"
/*  1886 */ "DH_INFO\0"
/*  1894 */ "dh-info\0"
/*  1902 */ "Loads a private key file\0"
/*  1927 */ "LOAD_PRIVKEY\0"
/*  1940 */ "load-privkey\0"
/*  1953 */ "Loads a public key file\0"
/*  1977 */ "LOAD_PUBKEY\0"
/*  1989 */ "load-pubkey\0"
/*  2001 */ "Loads a certificate request file\0"
/*  2034 */ "LOAD_REQUEST\0"
/*  2047 */ "load-request\0"
/*  2060 */ "Loads a certificate file\0"
/*  2085 */ "LOAD_CERTIFICATE\0"
/*  2102 */ "load-certificate\0"
/*  2119 */ "Loads the certificate authority's private key file\0"
/*  2170 */ "LOAD_CA_PRIVKEY\0"
/*  2186 */ "load-ca-privkey\0"
/*  2202 */ "Loads the certificate authority's certificate file\0"
/*  2253 */ "LOAD_CA_CERTIFICATE\0"
/*  2273 */ "load-ca-certificate\0"
/*  2293 */ "Password to use\0"
/*  2309 */ "PASSWORD\0"
/*  2318 */ "password\0"
/*  2327 */ "Print big number in an easier format to parse\0"
/*  2373 */ "HEX_NUMBERS\0"
/*  2385 */ "hex-numbers\0"
/*  2397 */ "Enforce a NULL password\0"
/*  2421 */ "NULL_PASSWORD\0"
/*  2435 */ "null-password\0"
/*  2449 */ "Print information on the given certificate\0"
/*  2492 */ "CERTIFICATE_INFO\0"
/*  2509 */ "certificate-info\0"
/*  2526 */ "Print certificate's public key\0"
/*  2557 */ "CERTIFICATE_PUBKEY\0"
/*  2576 */ "certificate-pubkey\0"
/*  2595 */ "Print information on the given OpenPGP certificate\0"
/*  2646 */ "PGP_CERTIFICATE_INFO\0"
/*  2667 */ "pgp-certificate-info\0"
/*  2688 */ "Print information on the given OpenPGP keyring structure\0"
/*  2745 */ "PGP_RING_INFO\0"
/*  2759 */ "pgp-ring-info\0"
/*  2773 */ "Print information on the given CRL structure\0"
/*  2818 */ "CRL_INFO\0"
/*  2827 */ "crl-info\0"
/*  2836 */ "Print information on the given certificate request\0"
/*  2887 */ "CRQ_INFO\0"
/*  2896 */ "crq-info\0"
/*  2905 */ "Do not use extensions in certificate requests\0"
/*  2951 */ "NO_CRQ_EXTENSIONS\0"
/*  2969 */ "no-crq-extensions\0"
/*  2987 */ "Print information on a PKCS #12 structure\0"
/*  3029 */ "P12_INFO\0"
/*  3038 */ "p12-info\0"
/*  3047 */ "Print information on a PKCS #7 structure\0"
/*  3088 */ "P7_INFO\0"
/*  3096 */ "p7-info\0"
/*  3104 */ "Convert S/MIME to PKCS #7 structure\0"
/*  3140 */ "SMIME_TO_P7\0"
/*  3152 */ "smime-to-p7\0"
/*  3164 */ "Print information on a private key\0"
/*  3199 */ "KEY_INFO\0"
/*  3208 */ "key-info\0"
/*  3217 */ "Print information on an OpenPGP private key\0"
/*  3261 */ "PGP_KEY_INFO\0"
/*  3274 */ "pgp-key-info\0"
/*  3287 */ "Print information on a public key\0"
/*  3321 */ "PUBKEY_INFO\0"
/*  3333 */ "pubkey-info\0"
/*  3345 */ "Generate an X.509 version 1 certificate (with no extensions)\0"
/*  3406 */ "V1\0"
/*  3409 */ "v1\0"
/*  3412 */ "Generate a PKCS #12 structure\0"
/*  3442 */ "TO_P12\0"
/*  3449 */ "to-p12\0"
/*  3456 */ "Generate a PKCS #8 structure\0"
/*  3485 */ "TO_P8\0"
/*  3491 */ "to-p8\0"
/*  3497 */ "Use PKCS #8 format for private keys\0"
/*  3533 */ "PKCS8\0"
/*  3539 */ "pkcs8\0"
/*  3545 */ "Generate RSA key\0"
/*  3562 */ "RSA\0"
/*  3566 */ "rsa\0"
/*  3570 */ "Generate DSA key\0"
/*  3587 */ "DSA\0"
/*  3591 */ "dsa\0"
/*  3595 */ "Generate ECC (ECDSA) key\0"
/*  3620 */ "ECC\0"
/*  3624 */ "ecc\0"
/*  3628 */ "This is an alias for 'ecc'\0"
/*  3655 */ "ecdsa\0"
/*  3661 */ "Hash algorithm to use for signing.\0"
/*  3696 */ "HASH\0"
/*  3701 */ "hash\0"
/*  3706 */ "Use DER format for input certificates and private keys.\0"
/*  3762 */ "INDER\0"
/*  3768 */ "no-inder\0"
/*  3777 */ "no\0"
/*  3780 */ "This is an alias for 'inder'\0"
/*  3809 */ "inraw\0"
/*  3815 */ "Use DER format for output certificates and private keys\0"
/*  3871 */ "OUTDER\0"
/*  3878 */ "no-outder\0"
/*  3888 */ "This is an alias for 'outder'\0"
/*  3918 */ "outraw\0"
/*  3925 */ "Specify the number of bits for key generate\0"
/*  3969 */ "BITS\0"
/*  3974 */ "bits\0"
/*  3979 */ "Specify the security level [low, legacy, normal, high, ultra].\0"
/*  4042 */ "SEC_PARAM\0"
/*  4052 */ "sec-param\0"
/*  4062 */ "No effect\0"
/*  4072 */ "DISABLE_QUICK_RANDOM\0"
/*  4093 */ "disable-quick-random\0"
/*  4114 */ "Template file to use for non-interactive operation\0"
/*  4165 */ "TEMPLATE\0"
/*  4174 */ "template\0"
/*  4183 */ "Cipher to use for PKCS #8 and #12 operations\0"
/*  4228 */ "PKCS_CIPHER\0"
/*  4240 */ "pkcs-cipher\0"
/*  4252 */ "Display extended usage information and exit\0"
/*  4296 */ "help\0"
/*  4301 */ "Extended usage information passed thru pager\0"
/*  4346 */ "more-help\0"
/*  4356 */ "Output version information and exit\0"
/*  4392 */ "version\0"
/*  4400 */ "CERTTOOL\0"
/*  4409 */ "certtool - GnuTLS certificate tool - Ver. @VERSION@\n"
            "USAGE:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]...\n\0"
/*  4519 */ "bug-gnutls@gnu.org\0"
/*  4538 */ "\n\n\0"
/*  4541 */ "\n"
            "Tool to parse and generate X.509 certificates, requests and private keys.\n"
            "It can be used interactively or non interactively by specifying the\n"
            "template command line option.\n\0"
/*  4715 */ "certtool @VERSION@\0"
/*  4734 */ "certtool [options]\n"
            "certtool --help for usage instructions.\n";

/*
 *  debug option description:
 */
#define DEBUG_DESC      (certtool_opt_strs+884)
#define DEBUG_NAME      (certtool_opt_strs+902)
#define DEBUG_name      (certtool_opt_strs+908)
#define DEBUG_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))

/*
 *  verbose option description:
 */
#define VERBOSE_DESC      (certtool_opt_strs+914)
#define VERBOSE_NAME      (certtool_opt_strs+934)
#define VERBOSE_name      (certtool_opt_strs+942)
#define VERBOSE_FLAGS     (OPTST_DISABLED)

/*
 *  infile option description:
 */
#define INFILE_DESC      (certtool_opt_strs+950)
#define INFILE_NAME      (certtool_opt_strs+961)
#define INFILE_name      (certtool_opt_strs+968)
#define INFILE_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_FILE))

/*
 *  outfile option description:
 */
#define OUTFILE_DESC      (certtool_opt_strs+975)
#define OUTFILE_NAME      (certtool_opt_strs+987)
#define OUTFILE_name      (certtool_opt_strs+995)
#define OUTFILE_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  generate-self-signed option description:
 */
#define GENERATE_SELF_SIGNED_DESC      (certtool_opt_strs+1003)
#define GENERATE_SELF_SIGNED_NAME      (certtool_opt_strs+1038)
#define GENERATE_SELF_SIGNED_name      (certtool_opt_strs+1059)
#define GENERATE_SELF_SIGNED_FLAGS     (OPTST_DISABLED)

/*
 *  generate-certificate option description:
 */
#define GENERATE_CERTIFICATE_DESC      (certtool_opt_strs+1080)
#define GENERATE_CERTIFICATE_NAME      (certtool_opt_strs+1110)
#define GENERATE_CERTIFICATE_name      (certtool_opt_strs+1131)
#define GENERATE_CERTIFICATE_FLAGS     (OPTST_DISABLED)

/*
 *  generate-proxy option description:
 */
#define GENERATE_PROXY_DESC      (certtool_opt_strs+1152)
#define GENERATE_PROXY_NAME      (certtool_opt_strs+1182)
#define GENERATE_PROXY_name      (certtool_opt_strs+1197)
#define GENERATE_PROXY_FLAGS     (OPTST_DISABLED)

/*
 *  generate-crl option description:
 */
#define GENERATE_CRL_DESC      (certtool_opt_strs+1212)
#define GENERATE_CRL_NAME      (certtool_opt_strs+1227)
#define GENERATE_CRL_name      (certtool_opt_strs+1240)
#define GENERATE_CRL_FLAGS     (OPTST_DISABLED)

/*
 *  update-certificate option description:
 */
#define UPDATE_CERTIFICATE_DESC      (certtool_opt_strs+1253)
#define UPDATE_CERTIFICATE_NAME      (certtool_opt_strs+1281)
#define UPDATE_CERTIFICATE_name      (certtool_opt_strs+1300)
#define UPDATE_CERTIFICATE_FLAGS     (OPTST_DISABLED)

/*
 *  generate-privkey option description:
 */
#define GENERATE_PRIVKEY_DESC      (certtool_opt_strs+1319)
#define GENERATE_PRIVKEY_NAME      (certtool_opt_strs+1342)
#define GENERATE_PRIVKEY_name      (certtool_opt_strs+1359)
#define GENERATE_PRIVKEY_FLAGS     (OPTST_DISABLED)

/*
 *  generate-request option description:
 */
#define GENERATE_REQUEST_DESC      (certtool_opt_strs+1376)
#define GENERATE_REQUEST_NAME      (certtool_opt_strs+1416)
#define GENERATE_REQUEST_name      (certtool_opt_strs+1433)
#define GENERATE_REQUEST_FLAGS     (OPTST_DISABLED)

/*
 *  verify-chain option description:
 */
#define VERIFY_CHAIN_DESC      (certtool_opt_strs+1450)
#define VERIFY_CHAIN_NAME      (certtool_opt_strs+1490)
#define VERIFY_CHAIN_name      (certtool_opt_strs+1503)
#define VERIFY_CHAIN_FLAGS     (OPTST_DISABLED)

/*
 *  verify option description with
 *  "Must also have options" and "Incompatible options":
 */
#define VERIFY_DESC      (certtool_opt_strs+1516)
#define VERIFY_NAME      (certtool_opt_strs+1577)
#define VERIFY_name      (certtool_opt_strs+1584)
static int const aVerifyMustList[] = {
    INDEX_OPT_LOAD_CA_CERTIFICATE, NO_EQUIVALENT };
#define VERIFY_FLAGS     (OPTST_DISABLED)

/*
 *  verify-crl option description with
 *  "Must also have options" and "Incompatible options":
 */
#define VERIFY_CRL_DESC      (certtool_opt_strs+1591)
#define VERIFY_CRL_NAME      (certtool_opt_strs+1626)
#define VERIFY_CRL_name      (certtool_opt_strs+1637)
static int const aVerify_CrlMustList[] = {
    INDEX_OPT_LOAD_CA_CERTIFICATE, NO_EQUIVALENT };
#define VERIFY_CRL_FLAGS     (OPTST_DISABLED)

/*
 *  generate-dh-params option description:
 */
#define GENERATE_DH_PARAMS_DESC      (certtool_opt_strs+1648)
#define GENERATE_DH_PARAMS_NAME      (certtool_opt_strs+1700)
#define GENERATE_DH_PARAMS_name      (certtool_opt_strs+1719)
#define GENERATE_DH_PARAMS_FLAGS     (OPTST_DISABLED)

/*
 *  get-dh-params option description:
 */
#define GET_DH_PARAMS_DESC      (certtool_opt_strs+1738)
#define GET_DH_PARAMS_NAME      (certtool_opt_strs+1798)
#define GET_DH_PARAMS_name      (certtool_opt_strs+1812)
#define GET_DH_PARAMS_FLAGS     (OPTST_DISABLED)

/*
 *  dh-info option description:
 */
#define DH_INFO_DESC      (certtool_opt_strs+1826)
#define DH_INFO_NAME      (certtool_opt_strs+1886)
#define DH_INFO_name      (certtool_opt_strs+1894)
#define DH_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  load-privkey option description:
 */
#define LOAD_PRIVKEY_DESC      (certtool_opt_strs+1902)
#define LOAD_PRIVKEY_NAME      (certtool_opt_strs+1927)
#define LOAD_PRIVKEY_name      (certtool_opt_strs+1940)
#define LOAD_PRIVKEY_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  load-pubkey option description:
 */
#define LOAD_PUBKEY_DESC      (certtool_opt_strs+1953)
#define LOAD_PUBKEY_NAME      (certtool_opt_strs+1977)
#define LOAD_PUBKEY_name      (certtool_opt_strs+1989)
#define LOAD_PUBKEY_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  load-request option description:
 */
#define LOAD_REQUEST_DESC      (certtool_opt_strs+2001)
#define LOAD_REQUEST_NAME      (certtool_opt_strs+2034)
#define LOAD_REQUEST_name      (certtool_opt_strs+2047)
#define LOAD_REQUEST_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_FILE))

/*
 *  load-certificate option description:
 */
#define LOAD_CERTIFICATE_DESC      (certtool_opt_strs+2060)
#define LOAD_CERTIFICATE_NAME      (certtool_opt_strs+2085)
#define LOAD_CERTIFICATE_name      (certtool_opt_strs+2102)
#define LOAD_CERTIFICATE_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  load-ca-privkey option description:
 */
#define LOAD_CA_PRIVKEY_DESC      (certtool_opt_strs+2119)
#define LOAD_CA_PRIVKEY_NAME      (certtool_opt_strs+2170)
#define LOAD_CA_PRIVKEY_name      (certtool_opt_strs+2186)
#define LOAD_CA_PRIVKEY_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  load-ca-certificate option description:
 */
#define LOAD_CA_CERTIFICATE_DESC      (certtool_opt_strs+2202)
#define LOAD_CA_CERTIFICATE_NAME      (certtool_opt_strs+2253)
#define LOAD_CA_CERTIFICATE_name      (certtool_opt_strs+2273)
#define LOAD_CA_CERTIFICATE_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  password option description:
 */
#define PASSWORD_DESC      (certtool_opt_strs+2293)
#define PASSWORD_NAME      (certtool_opt_strs+2309)
#define PASSWORD_name      (certtool_opt_strs+2318)
#define PASSWORD_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  hex-numbers option description:
 */
#define HEX_NUMBERS_DESC      (certtool_opt_strs+2327)
#define HEX_NUMBERS_NAME      (certtool_opt_strs+2373)
#define HEX_NUMBERS_name      (certtool_opt_strs+2385)
#define HEX_NUMBERS_FLAGS     (OPTST_DISABLED)

/*
 *  null-password option description:
 */
#define NULL_PASSWORD_DESC      (certtool_opt_strs+2397)
#define NULL_PASSWORD_NAME      (certtool_opt_strs+2421)
#define NULL_PASSWORD_name      (certtool_opt_strs+2435)
#define NULL_PASSWORD_FLAGS     (OPTST_DISABLED)

/*
 *  certificate-info option description:
 */
#define CERTIFICATE_INFO_DESC      (certtool_opt_strs+2449)
#define CERTIFICATE_INFO_NAME      (certtool_opt_strs+2492)
#define CERTIFICATE_INFO_name      (certtool_opt_strs+2509)
#define CERTIFICATE_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  certificate-pubkey option description:
 */
#define CERTIFICATE_PUBKEY_DESC      (certtool_opt_strs+2526)
#define CERTIFICATE_PUBKEY_NAME      (certtool_opt_strs+2557)
#define CERTIFICATE_PUBKEY_name      (certtool_opt_strs+2576)
#define CERTIFICATE_PUBKEY_FLAGS     (OPTST_DISABLED)

/*
 *  pgp-certificate-info option description:
 */
#define PGP_CERTIFICATE_INFO_DESC      (certtool_opt_strs+2595)
#define PGP_CERTIFICATE_INFO_NAME      (certtool_opt_strs+2646)
#define PGP_CERTIFICATE_INFO_name      (certtool_opt_strs+2667)
#define PGP_CERTIFICATE_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  pgp-ring-info option description:
 */
#define PGP_RING_INFO_DESC      (certtool_opt_strs+2688)
#define PGP_RING_INFO_NAME      (certtool_opt_strs+2745)
#define PGP_RING_INFO_name      (certtool_opt_strs+2759)
#define PGP_RING_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  crl-info option description:
 */
#define CRL_INFO_DESC      (certtool_opt_strs+2773)
#define CRL_INFO_NAME      (certtool_opt_strs+2818)
#define CRL_INFO_name      (certtool_opt_strs+2827)
#define CRL_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  crq-info option description:
 */
#define CRQ_INFO_DESC      (certtool_opt_strs+2836)
#define CRQ_INFO_NAME      (certtool_opt_strs+2887)
#define CRQ_INFO_name      (certtool_opt_strs+2896)
#define CRQ_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  no-crq-extensions option description:
 */
#define NO_CRQ_EXTENSIONS_DESC      (certtool_opt_strs+2905)
#define NO_CRQ_EXTENSIONS_NAME      (certtool_opt_strs+2951)
#define NO_CRQ_EXTENSIONS_name      (certtool_opt_strs+2969)
#define NO_CRQ_EXTENSIONS_FLAGS     (OPTST_DISABLED)

/*
 *  p12-info option description:
 */
#define P12_INFO_DESC      (certtool_opt_strs+2987)
#define P12_INFO_NAME      (certtool_opt_strs+3029)
#define P12_INFO_name      (certtool_opt_strs+3038)
#define P12_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  p7-info option description:
 */
#define P7_INFO_DESC      (certtool_opt_strs+3047)
#define P7_INFO_NAME      (certtool_opt_strs+3088)
#define P7_INFO_name      (certtool_opt_strs+3096)
#define P7_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  smime-to-p7 option description:
 */
#define SMIME_TO_P7_DESC      (certtool_opt_strs+3104)
#define SMIME_TO_P7_NAME      (certtool_opt_strs+3140)
#define SMIME_TO_P7_name      (certtool_opt_strs+3152)
#define SMIME_TO_P7_FLAGS     (OPTST_DISABLED)

/*
 *  key-info option description:
 */
#define KEY_INFO_DESC      (certtool_opt_strs+3164)
#define KEY_INFO_NAME      (certtool_opt_strs+3199)
#define KEY_INFO_name      (certtool_opt_strs+3208)
#define KEY_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  pgp-key-info option description:
 */
#define PGP_KEY_INFO_DESC      (certtool_opt_strs+3217)
#define PGP_KEY_INFO_NAME      (certtool_opt_strs+3261)
#define PGP_KEY_INFO_name      (certtool_opt_strs+3274)
#define PGP_KEY_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  pubkey-info option description:
 */
#define PUBKEY_INFO_DESC      (certtool_opt_strs+3287)
#define PUBKEY_INFO_NAME      (certtool_opt_strs+3321)
#define PUBKEY_INFO_name      (certtool_opt_strs+3333)
#define PUBKEY_INFO_FLAGS     (OPTST_DISABLED)

/*
 *  v1 option description:
 */
#define V1_DESC      (certtool_opt_strs+3345)
#define V1_NAME      (certtool_opt_strs+3406)
#define V1_name      (certtool_opt_strs+3409)
#define V1_FLAGS     (OPTST_DISABLED)

/*
 *  to-p12 option description with
 *  "Must also have options" and "Incompatible options":
 */
#define TO_P12_DESC      (certtool_opt_strs+3412)
#define TO_P12_NAME      (certtool_opt_strs+3442)
#define TO_P12_name      (certtool_opt_strs+3449)
static int const aTo_P12MustList[] = {
    INDEX_OPT_LOAD_CERTIFICATE, NO_EQUIVALENT };
#define TO_P12_FLAGS     (OPTST_DISABLED)

/*
 *  to-p8 option description:
 */
#define TO_P8_DESC      (certtool_opt_strs+3456)
#define TO_P8_NAME      (certtool_opt_strs+3485)
#define TO_P8_name      (certtool_opt_strs+3491)
#define TO_P8_FLAGS     (OPTST_DISABLED)

/*
 *  pkcs8 option description:
 */
#define PKCS8_DESC      (certtool_opt_strs+3497)
#define PKCS8_NAME      (certtool_opt_strs+3533)
#define PKCS8_name      (certtool_opt_strs+3539)
#define PKCS8_FLAGS     (OPTST_DISABLED)

/*
 *  rsa option description:
 */
#define RSA_DESC      (certtool_opt_strs+3545)
#define RSA_NAME      (certtool_opt_strs+3562)
#define RSA_name      (certtool_opt_strs+3566)
#define RSA_FLAGS     (OPTST_DISABLED)

/*
 *  dsa option description:
 */
#define DSA_DESC      (certtool_opt_strs+3570)
#define DSA_NAME      (certtool_opt_strs+3587)
#define DSA_name      (certtool_opt_strs+3591)
#define DSA_FLAGS     (OPTST_DISABLED)

/*
 *  ecc option description:
 */
#define ECC_DESC      (certtool_opt_strs+3595)
#define ECC_NAME      (certtool_opt_strs+3620)
#define ECC_name      (certtool_opt_strs+3624)
#define ECC_FLAGS     (OPTST_DISABLED)

/*
 *  ecdsa option description:
 */
#define ECDSA_DESC    (certtool_opt_strs+3628)
#define ECDSA_NAME    NULL
#define ECDSA_name    (certtool_opt_strs+3655)
#define ECDSA_FLAGS     (ECC_FLAGS | OPTST_ALIAS)

/*
 *  hash option description:
 */
#define HASH_DESC      (certtool_opt_strs+3661)
#define HASH_NAME      (certtool_opt_strs+3696)
#define HASH_name      (certtool_opt_strs+3701)
#define HASH_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  inder option description:
 */
#define INDER_DESC      (certtool_opt_strs+3706)
#define INDER_NAME      (certtool_opt_strs+3762)
#define NOT_INDER_name  (certtool_opt_strs+3768)
#define NOT_INDER_PFX   (certtool_opt_strs+3777)
#define INDER_name      (NOT_INDER_name + 3)
#define INDER_FLAGS     (OPTST_DISABLED)

/*
 *  inraw option description:
 */
#define INRAW_DESC    (certtool_opt_strs+3780)
#define INRAW_NAME    NULL
#define INRAW_name    (certtool_opt_strs+3809)
#define INRAW_FLAGS     (INDER_FLAGS | OPTST_ALIAS)

/*
 *  outder option description:
 */
#define OUTDER_DESC      (certtool_opt_strs+3815)
#define OUTDER_NAME      (certtool_opt_strs+3871)
#define NOT_OUTDER_name  (certtool_opt_strs+3878)
#define NOT_OUTDER_PFX   (certtool_opt_strs+3777)
#define OUTDER_name      (NOT_OUTDER_name + 3)
#define OUTDER_FLAGS     (OPTST_DISABLED)

/*
 *  outraw option description:
 */
#define OUTRAW_DESC    (certtool_opt_strs+3888)
#define OUTRAW_NAME    NULL
#define OUTRAW_name    (certtool_opt_strs+3918)
#define OUTRAW_FLAGS     (OUTDER_FLAGS | OPTST_ALIAS)

/*
 *  bits option description:
 */
#define BITS_DESC      (certtool_opt_strs+3925)
#define BITS_NAME      (certtool_opt_strs+3969)
#define BITS_name      (certtool_opt_strs+3974)
#define BITS_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))

/*
 *  sec-param option description:
 */
#define SEC_PARAM_DESC      (certtool_opt_strs+3979)
#define SEC_PARAM_NAME      (certtool_opt_strs+4042)
#define SEC_PARAM_name      (certtool_opt_strs+4052)
#define SEC_PARAM_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  disable-quick-random option description:
 */
#define DISABLE_QUICK_RANDOM_DESC      (certtool_opt_strs+4062)
#define DISABLE_QUICK_RANDOM_NAME      (certtool_opt_strs+4072)
#define DISABLE_QUICK_RANDOM_name      (certtool_opt_strs+4093)
#define DISABLE_QUICK_RANDOM_FLAGS     (OPTST_DISABLED)

/*
 *  template option description:
 */
#define TEMPLATE_DESC      (certtool_opt_strs+4114)
#define TEMPLATE_NAME      (certtool_opt_strs+4165)
#define TEMPLATE_name      (certtool_opt_strs+4174)
#define TEMPLATE_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_FILE))

/*
 *  pkcs-cipher option description:
 */
#define PKCS_CIPHER_DESC      (certtool_opt_strs+4183)
#define PKCS_CIPHER_NAME      (certtool_opt_strs+4228)
#define PKCS_CIPHER_name      (certtool_opt_strs+4240)
#define PKCS_CIPHER_FLAGS     (OPTST_DISABLED \
        | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))

/*
 *  Help/More_Help/Version option descriptions:
 */
#define HELP_DESC       (certtool_opt_strs+4252)
#define HELP_name       (certtool_opt_strs+4296)
#ifdef HAVE_WORKING_FORK
#define MORE_HELP_DESC  (certtool_opt_strs+4301)
#define MORE_HELP_name  (certtool_opt_strs+4346)
#define MORE_HELP_FLAGS (OPTST_IMM | OPTST_NO_INIT)
#else
#define MORE_HELP_DESC  NULL
#define MORE_HELP_name  NULL
#define MORE_HELP_FLAGS (OPTST_OMITTED | OPTST_NO_INIT)
#endif
#ifdef NO_OPTIONAL_OPT_ARGS
#  define VER_FLAGS     (OPTST_IMM | OPTST_NO_INIT)
#else
#  define VER_FLAGS     (OPTST_SET_ARGTYPE(OPARG_TYPE_STRING) | \
                         OPTST_ARG_OPTIONAL | OPTST_IMM | OPTST_NO_INIT)
#endif
#define VER_DESC        (certtool_opt_strs+4356)
#define VER_name        (certtool_opt_strs+4392)
/*
 *  Declare option callback procedures
 */
extern tOptProc
    optionBooleanVal,   optionNestedVal,    optionNumericVal,
    optionPagedUsage,   optionPrintVersion, optionResetOpt,
    optionStackArg,     optionTimeDate,     optionTimeVal,
    optionUnstackArg,   optionVendorOption;
static tOptProc
    doOptDebug,        doOptEcdsa,        doOptInfile,
    doOptInraw,        doOptLoad_Request, doOptOutraw,
    doOptTemplate,     doUsageOpt;
#define VER_PROC        optionPrintVersion

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 *  Define the certtool Option Descriptions.
 * This is an array of OPTION_CT entries, one for each
 * option that the certtool program responds to.
 */
static tOptDesc optDesc[OPTION_CT] = {
  {  /* entry idx, value */ 0, VALUE_OPT_DEBUG,
     /* equiv idx, value */ 0, VALUE_OPT_DEBUG,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ DEBUG_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --debug */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptDebug,
     /* desc, NAME, name */ DEBUG_DESC, DEBUG_NAME, DEBUG_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 1, VALUE_OPT_VERBOSE,
     /* equiv idx, value */ 1, VALUE_OPT_VERBOSE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, NOLIMIT, 0,
     /* opt state flags  */ VERBOSE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --verbose */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ VERBOSE_DESC, VERBOSE_NAME, VERBOSE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 2, VALUE_OPT_INFILE,
     /* equiv idx, value */ 2, VALUE_OPT_INFILE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ INFILE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --infile */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptInfile,
     /* desc, NAME, name */ INFILE_DESC, INFILE_NAME, INFILE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 3, VALUE_OPT_OUTFILE,
     /* equiv idx, value */ 3, VALUE_OPT_OUTFILE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ OUTFILE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --outfile */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ OUTFILE_DESC, OUTFILE_NAME, OUTFILE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 4, VALUE_OPT_GENERATE_SELF_SIGNED,
     /* equiv idx, value */ 4, VALUE_OPT_GENERATE_SELF_SIGNED,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_SELF_SIGNED_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-self-signed */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_SELF_SIGNED_DESC, GENERATE_SELF_SIGNED_NAME, GENERATE_SELF_SIGNED_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 5, VALUE_OPT_GENERATE_CERTIFICATE,
     /* equiv idx, value */ 5, VALUE_OPT_GENERATE_CERTIFICATE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_CERTIFICATE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-certificate */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_CERTIFICATE_DESC, GENERATE_CERTIFICATE_NAME, GENERATE_CERTIFICATE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 6, VALUE_OPT_GENERATE_PROXY,
     /* equiv idx, value */ 6, VALUE_OPT_GENERATE_PROXY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_PROXY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-proxy */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_PROXY_DESC, GENERATE_PROXY_NAME, GENERATE_PROXY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 7, VALUE_OPT_GENERATE_CRL,
     /* equiv idx, value */ 7, VALUE_OPT_GENERATE_CRL,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_CRL_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-crl */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_CRL_DESC, GENERATE_CRL_NAME, GENERATE_CRL_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 8, VALUE_OPT_UPDATE_CERTIFICATE,
     /* equiv idx, value */ 8, VALUE_OPT_UPDATE_CERTIFICATE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ UPDATE_CERTIFICATE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --update-certificate */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ UPDATE_CERTIFICATE_DESC, UPDATE_CERTIFICATE_NAME, UPDATE_CERTIFICATE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 9, VALUE_OPT_GENERATE_PRIVKEY,
     /* equiv idx, value */ 9, VALUE_OPT_GENERATE_PRIVKEY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_PRIVKEY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-privkey */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_PRIVKEY_DESC, GENERATE_PRIVKEY_NAME, GENERATE_PRIVKEY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 10, VALUE_OPT_GENERATE_REQUEST,
     /* equiv idx, value */ 10, VALUE_OPT_GENERATE_REQUEST,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_REQUEST_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-request */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_REQUEST_DESC, GENERATE_REQUEST_NAME, GENERATE_REQUEST_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 11, VALUE_OPT_VERIFY_CHAIN,
     /* equiv idx, value */ 11, VALUE_OPT_VERIFY_CHAIN,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ VERIFY_CHAIN_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --verify-chain */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ VERIFY_CHAIN_DESC, VERIFY_CHAIN_NAME, VERIFY_CHAIN_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 12, VALUE_OPT_VERIFY,
     /* equiv idx, value */ 12, VALUE_OPT_VERIFY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ VERIFY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --verify */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ aVerifyMustList, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ VERIFY_DESC, VERIFY_NAME, VERIFY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 13, VALUE_OPT_VERIFY_CRL,
     /* equiv idx, value */ 13, VALUE_OPT_VERIFY_CRL,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ VERIFY_CRL_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --verify-crl */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ aVerify_CrlMustList, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ VERIFY_CRL_DESC, VERIFY_CRL_NAME, VERIFY_CRL_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 14, VALUE_OPT_GENERATE_DH_PARAMS,
     /* equiv idx, value */ 14, VALUE_OPT_GENERATE_DH_PARAMS,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GENERATE_DH_PARAMS_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --generate-dh-params */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GENERATE_DH_PARAMS_DESC, GENERATE_DH_PARAMS_NAME, GENERATE_DH_PARAMS_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 15, VALUE_OPT_GET_DH_PARAMS,
     /* equiv idx, value */ 15, VALUE_OPT_GET_DH_PARAMS,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ GET_DH_PARAMS_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --get-dh-params */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ GET_DH_PARAMS_DESC, GET_DH_PARAMS_NAME, GET_DH_PARAMS_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 16, VALUE_OPT_DH_INFO,
     /* equiv idx, value */ 16, VALUE_OPT_DH_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ DH_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --dh-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ DH_INFO_DESC, DH_INFO_NAME, DH_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 17, VALUE_OPT_LOAD_PRIVKEY,
     /* equiv idx, value */ 17, VALUE_OPT_LOAD_PRIVKEY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_PRIVKEY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-privkey */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ LOAD_PRIVKEY_DESC, LOAD_PRIVKEY_NAME, LOAD_PRIVKEY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 18, VALUE_OPT_LOAD_PUBKEY,
     /* equiv idx, value */ 18, VALUE_OPT_LOAD_PUBKEY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_PUBKEY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-pubkey */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ LOAD_PUBKEY_DESC, LOAD_PUBKEY_NAME, LOAD_PUBKEY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 19, VALUE_OPT_LOAD_REQUEST,
     /* equiv idx, value */ 19, VALUE_OPT_LOAD_REQUEST,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_REQUEST_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-request */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptLoad_Request,
     /* desc, NAME, name */ LOAD_REQUEST_DESC, LOAD_REQUEST_NAME, LOAD_REQUEST_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 20, VALUE_OPT_LOAD_CERTIFICATE,
     /* equiv idx, value */ 20, VALUE_OPT_LOAD_CERTIFICATE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_CERTIFICATE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-certificate */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ LOAD_CERTIFICATE_DESC, LOAD_CERTIFICATE_NAME, LOAD_CERTIFICATE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 21, VALUE_OPT_LOAD_CA_PRIVKEY,
     /* equiv idx, value */ 21, VALUE_OPT_LOAD_CA_PRIVKEY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_CA_PRIVKEY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-ca-privkey */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ LOAD_CA_PRIVKEY_DESC, LOAD_CA_PRIVKEY_NAME, LOAD_CA_PRIVKEY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 22, VALUE_OPT_LOAD_CA_CERTIFICATE,
     /* equiv idx, value */ 22, VALUE_OPT_LOAD_CA_CERTIFICATE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ LOAD_CA_CERTIFICATE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --load-ca-certificate */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ LOAD_CA_CERTIFICATE_DESC, LOAD_CA_CERTIFICATE_NAME, LOAD_CA_CERTIFICATE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 23, VALUE_OPT_PASSWORD,
     /* equiv idx, value */ 23, VALUE_OPT_PASSWORD,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PASSWORD_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --password */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PASSWORD_DESC, PASSWORD_NAME, PASSWORD_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 24, VALUE_OPT_HEX_NUMBERS,
     /* equiv idx, value */ 24, VALUE_OPT_HEX_NUMBERS,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ HEX_NUMBERS_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --hex-numbers */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ HEX_NUMBERS_DESC, HEX_NUMBERS_NAME, HEX_NUMBERS_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 25, VALUE_OPT_NULL_PASSWORD,
     /* equiv idx, value */ 25, VALUE_OPT_NULL_PASSWORD,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ NULL_PASSWORD_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --null-password */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ NULL_PASSWORD_DESC, NULL_PASSWORD_NAME, NULL_PASSWORD_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 26, VALUE_OPT_CERTIFICATE_INFO,
     /* equiv idx, value */ 26, VALUE_OPT_CERTIFICATE_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ CERTIFICATE_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --certificate-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ CERTIFICATE_INFO_DESC, CERTIFICATE_INFO_NAME, CERTIFICATE_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 27, VALUE_OPT_CERTIFICATE_PUBKEY,
     /* equiv idx, value */ 27, VALUE_OPT_CERTIFICATE_PUBKEY,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ CERTIFICATE_PUBKEY_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --certificate-pubkey */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ CERTIFICATE_PUBKEY_DESC, CERTIFICATE_PUBKEY_NAME, CERTIFICATE_PUBKEY_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 28, VALUE_OPT_PGP_CERTIFICATE_INFO,
     /* equiv idx, value */ 28, VALUE_OPT_PGP_CERTIFICATE_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PGP_CERTIFICATE_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pgp-certificate-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PGP_CERTIFICATE_INFO_DESC, PGP_CERTIFICATE_INFO_NAME, PGP_CERTIFICATE_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 29, VALUE_OPT_PGP_RING_INFO,
     /* equiv idx, value */ 29, VALUE_OPT_PGP_RING_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PGP_RING_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pgp-ring-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PGP_RING_INFO_DESC, PGP_RING_INFO_NAME, PGP_RING_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 30, VALUE_OPT_CRL_INFO,
     /* equiv idx, value */ 30, VALUE_OPT_CRL_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ CRL_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --crl-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ CRL_INFO_DESC, CRL_INFO_NAME, CRL_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 31, VALUE_OPT_CRQ_INFO,
     /* equiv idx, value */ 31, VALUE_OPT_CRQ_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ CRQ_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --crq-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ CRQ_INFO_DESC, CRQ_INFO_NAME, CRQ_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 32, VALUE_OPT_NO_CRQ_EXTENSIONS,
     /* equiv idx, value */ 32, VALUE_OPT_NO_CRQ_EXTENSIONS,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ NO_CRQ_EXTENSIONS_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --no-crq-extensions */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ NO_CRQ_EXTENSIONS_DESC, NO_CRQ_EXTENSIONS_NAME, NO_CRQ_EXTENSIONS_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 33, VALUE_OPT_P12_INFO,
     /* equiv idx, value */ 33, VALUE_OPT_P12_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ P12_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --p12-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ P12_INFO_DESC, P12_INFO_NAME, P12_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 34, VALUE_OPT_P7_INFO,
     /* equiv idx, value */ 34, VALUE_OPT_P7_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ P7_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --p7-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ P7_INFO_DESC, P7_INFO_NAME, P7_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 35, VALUE_OPT_SMIME_TO_P7,
     /* equiv idx, value */ 35, VALUE_OPT_SMIME_TO_P7,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ SMIME_TO_P7_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --smime-to-p7 */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ SMIME_TO_P7_DESC, SMIME_TO_P7_NAME, SMIME_TO_P7_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 36, VALUE_OPT_KEY_INFO,
     /* equiv idx, value */ 36, VALUE_OPT_KEY_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ KEY_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --key-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ KEY_INFO_DESC, KEY_INFO_NAME, KEY_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 37, VALUE_OPT_PGP_KEY_INFO,
     /* equiv idx, value */ 37, VALUE_OPT_PGP_KEY_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PGP_KEY_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pgp-key-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PGP_KEY_INFO_DESC, PGP_KEY_INFO_NAME, PGP_KEY_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 38, VALUE_OPT_PUBKEY_INFO,
     /* equiv idx, value */ 38, VALUE_OPT_PUBKEY_INFO,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PUBKEY_INFO_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pubkey-info */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PUBKEY_INFO_DESC, PUBKEY_INFO_NAME, PUBKEY_INFO_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 39, VALUE_OPT_V1,
     /* equiv idx, value */ 39, VALUE_OPT_V1,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ V1_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --v1 */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ V1_DESC, V1_NAME, V1_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 40, VALUE_OPT_TO_P12,
     /* equiv idx, value */ 40, VALUE_OPT_TO_P12,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ TO_P12_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --to-p12 */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ aTo_P12MustList, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ TO_P12_DESC, TO_P12_NAME, TO_P12_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 41, VALUE_OPT_TO_P8,
     /* equiv idx, value */ 41, VALUE_OPT_TO_P8,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ TO_P8_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --to-p8 */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ TO_P8_DESC, TO_P8_NAME, TO_P8_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 42, VALUE_OPT_PKCS8,
     /* equiv idx, value */ 42, VALUE_OPT_PKCS8,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PKCS8_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pkcs8 */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PKCS8_DESC, PKCS8_NAME, PKCS8_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 43, VALUE_OPT_RSA,
     /* equiv idx, value */ 43, VALUE_OPT_RSA,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ RSA_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --rsa */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ RSA_DESC, RSA_NAME, RSA_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 44, VALUE_OPT_DSA,
     /* equiv idx, value */ 44, VALUE_OPT_DSA,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ DSA_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --dsa */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ DSA_DESC, DSA_NAME, DSA_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 45, VALUE_OPT_ECC,
     /* equiv idx, value */ 45, VALUE_OPT_ECC,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ ECC_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --ecc */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ ECC_DESC, ECC_NAME, ECC_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 46, VALUE_OPT_ECDSA,
     /* equiv idx, value */ 46, VALUE_OPT_ECDSA,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ ECDSA_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --ecdsa */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptEcdsa,
     /* desc, NAME, name */ ECDSA_DESC, ECDSA_NAME, ECDSA_name,
     /* disablement strs */ 0, 0 },

  {  /* entry idx, value */ 47, VALUE_OPT_HASH,
     /* equiv idx, value */ 47, VALUE_OPT_HASH,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ HASH_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --hash */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ HASH_DESC, HASH_NAME, HASH_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 48, VALUE_OPT_INDER,
     /* equiv idx, value */ 48, VALUE_OPT_INDER,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ INDER_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --inder */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ INDER_DESC, INDER_NAME, INDER_name,
     /* disablement strs */ NOT_INDER_name, NOT_INDER_PFX },

  {  /* entry idx, value */ 49, VALUE_OPT_INRAW,
     /* equiv idx, value */ 49, VALUE_OPT_INRAW,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ INRAW_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --inraw */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptInraw,
     /* desc, NAME, name */ INRAW_DESC, INRAW_NAME, INRAW_name,
     /* disablement strs */ 0, 0 },

  {  /* entry idx, value */ 50, VALUE_OPT_OUTDER,
     /* equiv idx, value */ 50, VALUE_OPT_OUTDER,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ OUTDER_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --outder */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ OUTDER_DESC, OUTDER_NAME, OUTDER_name,
     /* disablement strs */ NOT_OUTDER_name, NOT_OUTDER_PFX },

  {  /* entry idx, value */ 51, VALUE_OPT_OUTRAW,
     /* equiv idx, value */ 51, VALUE_OPT_OUTRAW,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ OUTRAW_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --outraw */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptOutraw,
     /* desc, NAME, name */ OUTRAW_DESC, OUTRAW_NAME, OUTRAW_name,
     /* disablement strs */ 0, 0 },

  {  /* entry idx, value */ 52, VALUE_OPT_BITS,
     /* equiv idx, value */ 52, VALUE_OPT_BITS,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ BITS_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --bits */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ optionNumericVal,
     /* desc, NAME, name */ BITS_DESC, BITS_NAME, BITS_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 53, VALUE_OPT_SEC_PARAM,
     /* equiv idx, value */ 53, VALUE_OPT_SEC_PARAM,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ SEC_PARAM_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --sec-param */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ SEC_PARAM_DESC, SEC_PARAM_NAME, SEC_PARAM_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 54, VALUE_OPT_DISABLE_QUICK_RANDOM,
     /* equiv idx, value */ 54, VALUE_OPT_DISABLE_QUICK_RANDOM,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ DISABLE_QUICK_RANDOM_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --disable-quick-random */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ DISABLE_QUICK_RANDOM_DESC, DISABLE_QUICK_RANDOM_NAME, DISABLE_QUICK_RANDOM_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 55, VALUE_OPT_TEMPLATE,
     /* equiv idx, value */ 55, VALUE_OPT_TEMPLATE,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ TEMPLATE_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --template */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doOptTemplate,
     /* desc, NAME, name */ TEMPLATE_DESC, TEMPLATE_NAME, TEMPLATE_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ 56, VALUE_OPT_PKCS_CIPHER,
     /* equiv idx, value */ 56, VALUE_OPT_PKCS_CIPHER,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ PKCS_CIPHER_FLAGS, 0,
     /* last opt argumnt */ { NULL }, /* --pkcs-cipher */
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ NULL,
     /* desc, NAME, name */ PKCS_CIPHER_DESC, PKCS_CIPHER_NAME, PKCS_CIPHER_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ INDEX_OPT_VERSION, VALUE_OPT_VERSION,
     /* equiv idx value  */ NO_EQUIVALENT, VALUE_OPT_VERSION,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ VER_FLAGS, 0,
     /* last opt argumnt */ { NULL },
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ VER_PROC,
     /* desc, NAME, name */ VER_DESC, NULL, VER_name,
     /* disablement strs */ NULL, NULL },



  {  /* entry idx, value */ INDEX_OPT_HELP, VALUE_OPT_HELP,
     /* equiv idx value  */ NO_EQUIVALENT, VALUE_OPT_HELP,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ OPTST_IMM | OPTST_NO_INIT, 0,
     /* last opt argumnt */ { NULL },
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL, NULL,
     /* option proc      */ doUsageOpt,
     /* desc, NAME, name */ HELP_DESC, NULL, HELP_name,
     /* disablement strs */ NULL, NULL },

  {  /* entry idx, value */ INDEX_OPT_MORE_HELP, VALUE_OPT_MORE_HELP,
     /* equiv idx value  */ NO_EQUIVALENT, VALUE_OPT_MORE_HELP,
     /* equivalenced to  */ NO_EQUIVALENT,
     /* min, max, act ct */ 0, 1, 0,
     /* opt state flags  */ MORE_HELP_FLAGS, 0,
     /* last opt argumnt */ { NULL },
     /* arg list/cookie  */ NULL,
     /* must/cannot opts */ NULL,  NULL,
     /* option proc      */ optionPagedUsage,
     /* desc, NAME, name */ MORE_HELP_DESC, NULL, MORE_HELP_name,
     /* disablement strs */ NULL, NULL }
};


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Define the certtool Option Environment
 */
#define zPROGNAME       (certtool_opt_strs+4400)
#define zUsageTitle     (certtool_opt_strs+4409)
#define zRcName         NULL
#define apzHomeList     NULL
#define zBugsAddr       (certtool_opt_strs+4519)
#define zExplain        (certtool_opt_strs+4538)
#define zDetail         (certtool_opt_strs+4541)
#define zFullVersion    (certtool_opt_strs+4715)
/* extracted from optcode.tlib near line 350 */

#if defined(ENABLE_NLS)
# define OPTPROC_BASE OPTPROC_TRANSLATE | OPTPROC_NXLAT_OPT
  static tOptionXlateProc translate_option_strings;
#else
# define OPTPROC_BASE OPTPROC_NONE
# define translate_option_strings NULL
#endif /* ENABLE_NLS */


#define certtool_full_usage (NULL)

#define certtool_short_usage (certtool_opt_strs+4734)

#endif /* not defined __doxygen__ */

/*
 *  Create the static procedure(s) declared above.
 */
/**
 * The callout function that invokes the optionUsage function.
 *
 * @param pOptions the AutoOpts option description structure
 * @param pOptDesc the descriptor for the "help" (usage) option.
 * @noreturn
 */
static void
doUsageOpt(tOptions * pOptions, tOptDesc * pOptDesc)
{
    optionUsage(&certtoolOptions, CERTTOOL_EXIT_SUCCESS);
    /* NOTREACHED */
    (void)pOptDesc;
    (void)pOptions;
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the debug option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptDebug(tOptions* pOptions, tOptDesc* pOptDesc)
{
    static struct {long rmin, rmax;} const rng[1] = {
        { 0 ,  9999 } };
    int  ix;

    if (pOptions <= OPTPROC_EMIT_LIMIT)
        goto emit_ranges;
    optionNumericVal(pOptions, pOptDesc);

    for (ix = 0; ix < 1; ix++) {
        if (pOptDesc->optArg.argInt < rng[ix].rmin)
            continue;  /* ranges need not be ordered. */
        if (pOptDesc->optArg.argInt == rng[ix].rmin)
            return;
        if (rng[ix].rmax == LONG_MIN)
            continue;
        if (pOptDesc->optArg.argInt <= rng[ix].rmax)
            return;
    }

    option_usage_fp = stderr;

emit_ranges:

    optionShowRange(pOptions, pOptDesc, (void *)rng, 1);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the infile option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptInfile(tOptions* pOptions, tOptDesc* pOptDesc)
{
    static teOptFileType const  type =
        FTYPE_MODE_MUST_EXIST + FTYPE_MODE_NO_OPEN;
    static tuFileMode           mode;
#ifndef O_CLOEXEC
#  define O_CLOEXEC 0
#endif
    mode.file_flags = O_CLOEXEC;

    optionFileCheck(pOptions, pOptDesc, type, mode);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the load-request option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptLoad_Request(tOptions* pOptions, tOptDesc* pOptDesc)
{
    static teOptFileType const  type =
        FTYPE_MODE_MUST_EXIST + FTYPE_MODE_NO_OPEN;
    static tuFileMode           mode;
#ifndef O_CLOEXEC
#  define O_CLOEXEC 0
#endif
    mode.file_flags = O_CLOEXEC;

    optionFileCheck(pOptions, pOptDesc, type, mode);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the ecdsa option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptEcdsa(tOptions* pOptions, tOptDesc* pOptDesc)
{
    int res = optionAlias(pOptions, pOptDesc, INDEX_OPT_ECC);
    if ((res != 0) && ((pOptions->fOptSet & OPTPROC_ERRSTOP) != 0))
        USAGE(CERTTOOL_EXIT_FAILURE);

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the inraw option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptInraw(tOptions* pOptions, tOptDesc* pOptDesc)
{
    int res = optionAlias(pOptions, pOptDesc, INDEX_OPT_INDER);
    if ((res != 0) && ((pOptions->fOptSet & OPTPROC_ERRSTOP) != 0))
        USAGE(CERTTOOL_EXIT_FAILURE);

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the outraw option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptOutraw(tOptions* pOptions, tOptDesc* pOptDesc)
{
    int res = optionAlias(pOptions, pOptDesc, INDEX_OPT_OUTDER);
    if ((res != 0) && ((pOptions->fOptSet & OPTPROC_ERRSTOP) != 0))
        USAGE(CERTTOOL_EXIT_FAILURE);

}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/**
 * Code to handle the template option.
 *
 * @param pOptions the certtool options data structure
 * @param pOptDesc the option descriptor for this option.
 */
static void
doOptTemplate(tOptions* pOptions, tOptDesc* pOptDesc)
{
    static teOptFileType const  type =
        FTYPE_MODE_MUST_EXIST + FTYPE_MODE_NO_OPEN;
    static tuFileMode           mode;
#ifndef O_CLOEXEC
#  define O_CLOEXEC 0
#endif
    mode.file_flags = O_CLOEXEC;

    optionFileCheck(pOptions, pOptDesc, type, mode);
}
/* extracted from optmain.tlib near line 1113 */

/**
 * The directory containing the data associated with certtool.
 */
#ifndef  PKGDATADIR
# define PKGDATADIR ""
#endif

/**
 * Information about the person or institution that packaged certtool
 * for the current distribution.
 */
#ifndef  WITH_PACKAGER
# define certtool_packager_info NULL
#else
static char const certtool_packager_info[] =
    "Packaged by " WITH_PACKAGER

# ifdef WITH_PACKAGER_VERSION
        " ("WITH_PACKAGER_VERSION")"
# endif

# ifdef WITH_PACKAGER_BUG_REPORTS
    "\nReport certtool bugs to " WITH_PACKAGER_BUG_REPORTS
# endif
    "\n";
#endif
#ifndef __doxygen__

#endif /* __doxygen__ */
/**
 * The option definitions for certtool.  The one structure that
 * binds them all.
 */
tOptions certtoolOptions = {
    OPTIONS_STRUCT_VERSION,
    0, NULL,                    /* original argc + argv    */
    ( OPTPROC_BASE
    + OPTPROC_ERRSTOP
    + OPTPROC_SHORTOPT
    + OPTPROC_LONGOPT
    + OPTPROC_NO_REQ_OPT
    + OPTPROC_NEGATIONS
    + OPTPROC_NO_ARGS
    + OPTPROC_GNUUSAGE
    + OPTPROC_MISUSE ),
    0, NULL,                    /* current option index, current option */
    NULL,         NULL,         zPROGNAME,
    zRcName,      zCopyright,   zLicenseDescrip,
    zFullVersion, apzHomeList,  zUsageTitle,
    zExplain,     zDetail,      optDesc,
    zBugsAddr,                  /* address to send bugs to */
    NULL, NULL,                 /* extensions/saved state  */
    optionUsage, /* usage procedure */
    translate_option_strings,   /* translation procedure */
    /*
     *  Indexes to special options
     */
    { INDEX_OPT_MORE_HELP, /* more-help option index */
      NO_EQUIVALENT, /* save option index */
      NO_EQUIVALENT, /* '-#' option index */
      NO_EQUIVALENT /* index of default opt */
    },
    60 /* full option count */, 57 /* user option count */,
    certtool_full_usage, certtool_short_usage,
    NULL, NULL,
    PKGDATADIR, certtool_packager_info
};

#if ENABLE_NLS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <autoopts/usage-txt.h>

static char* AO_gettext(char const* pz);
static void  coerce_it(void** s);

/**
 * AutoGen specific wrapper function for gettext.
 * It relies on the macro _() to convert from English to the target
 * language, then strdup-duplicates the result string.
 *
 * @param[in] pz the input text used as a lookup key.
 * @returns the translated text (if there is one),
 *   or the original text (if not).
 */
static char *
AO_gettext(char const* pz)
{
    char* pzRes;
    if (pz == NULL)
        return NULL;
    pzRes = _(pz);
    if (pzRes == pz)
        return pzRes;
    pzRes = strdup(pzRes);
    if (pzRes == NULL) {
        fputs(_("No memory for duping translated strings\n"), stderr);
        exit(CERTTOOL_EXIT_FAILURE);
    }
    return pzRes;
}

static void coerce_it(void** s) { *s = AO_gettext(*s);
}

/**
 * Translate all the translatable strings in the certtoolOptions
 * structure defined above.  This is done only once.
 */
static void
translate_option_strings(void)
{
    tOptions * const pOpt = &certtoolOptions;

    /*
     *  Guard against re-translation.  It won't work.  The strings will have
     *  been changed by the first pass through this code.  One shot only.
     */
    if (option_usage_text.field_ct != 0) {
        /*
         *  Do the translations.  The first pointer follows the field count
         *  field.  The field count field is the size of a pointer.
         */
        tOptDesc * pOD = pOpt->pOptDesc;
        char **    ppz = (char**)(void*)&(option_usage_text);
        int        ix  = option_usage_text.field_ct;

        do {
            ppz++;
            *ppz = AO_gettext(*ppz);
        } while (--ix > 0);

        coerce_it((void*)&(pOpt->pzCopyright));
        coerce_it((void*)&(pOpt->pzCopyNotice));
        coerce_it((void*)&(pOpt->pzFullVersion));
        coerce_it((void*)&(pOpt->pzUsageTitle));
        coerce_it((void*)&(pOpt->pzExplain));
        coerce_it((void*)&(pOpt->pzDetail));
        coerce_it((void*)&(pOpt->pzPackager));
        coerce_it((void*)&(pOpt->pzShortUsage));
        option_usage_text.field_ct = 0;

        for (ix = pOpt->optCt; ix > 0; ix--, pOD++)
            coerce_it((void*)&(pOD->pzText));
    }

    if ((pOpt->fOptSet & OPTPROC_NXLAT_OPT_CFG) == 0) {
        tOptDesc * pOD = pOpt->pOptDesc;
        int        ix;

        for (ix = pOpt->optCt; ix > 0; ix--, pOD++) {
            coerce_it((void*)&(pOD->pz_Name));
            coerce_it((void*)&(pOD->pz_DisableName));
            coerce_it((void*)&(pOD->pz_DisablePfx));
        }
        /* prevent re-translation */
        certtoolOptions.fOptSet |= OPTPROC_NXLAT_OPT_CFG | OPTPROC_NXLAT_OPT;
    }
}

#endif /* ENABLE_NLS */

#ifdef  __cplusplus
}
#endif
/* certtool-args.c ends here */
